package net.minecraft.client.renderer.tileentity;

import com.klintos.twelve.Twelve;
import com.klintos.twelve.handlers.ModHandler;
import com.klintos.twelve.mod.Mod;
import java.util.Calendar;
import net.minecraft.block.Block;
import net.minecraft.block.BlockChest;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.model.ModelChest;
import net.minecraft.client.model.ModelLargeChest;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.tileentity.TileEntityChest;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ResourceLocation;
import net.minecraft.world.World;
import org.lwjgl.opengl.GL11;

public class TileEntityChestRenderer
extends TileEntitySpecialRenderer {
    private static final ResourceLocation textureTrappedDouble = new ResourceLocation("textures/entity/chest/trapped_double.png");
    private static final ResourceLocation textureChristmasDouble = new ResourceLocation("textures/entity/chest/christmas_double.png");
    private static final ResourceLocation textureNormalDouble = new ResourceLocation("textures/entity/chest/normal_double.png");
    private static final ResourceLocation textureTrapped = new ResourceLocation("textures/entity/chest/trapped.png");
    private static final ResourceLocation textureChristmas = new ResourceLocation("textures/entity/chest/christmas.png");
    private static final ResourceLocation textureNormal = new ResourceLocation("textures/entity/chest/normal.png");
    private ModelChest simpleChest = new ModelChest();
    private ModelChest largeChest = new ModelLargeChest();
    private boolean isChristams;
    private static final String __OBFID = "CL_00000965";
    public static int state = 0;
    public static float a = 255.0f;
    public static float r = 255.0f;
    public static float g = 0.0f;
    public static float b = 0.0f;

    public TileEntityChestRenderer() {
        Calendar var1 = Calendar.getInstance();
        if (var1.get(2) + 1 == 12 && var1.get(5) >= 24 && var1.get(5) <= 26) {
            this.isChristams = true;
        }
    }

    public void func_180538_a(TileEntityChest p_180538_1_, double p_180538_2_, double p_180538_4_, double p_180538_6_, float p_180538_8_, int p_180538_9_) {
        int var10;
        if (!p_180538_1_.hasWorldObj()) {
            var10 = 0;
        } else {
            Block var11 = p_180538_1_.getBlockType();
            var10 = p_180538_1_.getBlockMetadata();
            if (var11 instanceof BlockChest && var10 == 0) {
                ((BlockChest)var11).checkForSurroundingChests(p_180538_1_.getWorld(), p_180538_1_.getPos(), p_180538_1_.getWorld().getBlockState(p_180538_1_.getPos()));
                var10 = p_180538_1_.getBlockMetadata();
            }
            p_180538_1_.checkForAdjacentChests();
        }
        if (p_180538_1_.adjacentChestZNeg == null && p_180538_1_.adjacentChestXNeg == null) {
            ModelChest var15;
            float var14;
            if (p_180538_1_.adjacentChestXPos == null && p_180538_1_.adjacentChestZPos == null) {
                var15 = this.simpleChest;
                if (p_180538_9_ >= 0) {
                    this.bindTexture(DESTROY_STAGES[p_180538_9_]);
                    GlStateManager.matrixMode(5890);
                    GlStateManager.pushMatrix();
                    GlStateManager.scale(4.0f, 4.0f, 1.0f);
                    GlStateManager.translate(0.0625f, 0.0625f, 0.0625f);
                    GlStateManager.matrixMode(5888);
                } else if (p_180538_1_.getChestType() == 1) {
                    this.bindTexture(textureTrapped);
                } else if (this.isChristams) {
                    this.bindTexture(textureChristmas);
                } else {
                    this.bindTexture(textureNormal);
                }
            } else {
                var15 = this.largeChest;
                if (p_180538_9_ >= 0) {
                    this.bindTexture(DESTROY_STAGES[p_180538_9_]);
                    GlStateManager.matrixMode(5890);
                    GlStateManager.pushMatrix();
                    GlStateManager.scale(8.0f, 4.0f, 1.0f);
                    GlStateManager.translate(0.0625f, 0.0625f, 0.0625f);
                    GlStateManager.matrixMode(5888);
                } else if (p_180538_1_.getChestType() == 1) {
                    this.bindTexture(textureTrappedDouble);
                } else if (this.isChristams) {
                    this.bindTexture(textureChristmasDouble);
                } else {
                    this.bindTexture(textureNormalDouble);
                }
            }
            GlStateManager.pushMatrix();
            GlStateManager.enableRescaleNormal();
            if (p_180538_9_ < 0) {
                GlStateManager.color(1.0f, 1.0f, 1.0f, 1.0f);
            }
            GlStateManager.translate((float)p_180538_2_, (float)p_180538_4_ + 1.0f, (float)p_180538_6_ + 1.0f);
            GlStateManager.scale(1.0f, -1.0f, -1.0f);
            GlStateManager.translate(0.5f, 0.5f, 0.5f);
            int var12 = 0;
            if (var10 == 2) {
                var12 = 180;
            }
            if (var10 == 3) {
                var12 = 0;
            }
            if (var10 == 4) {
                var12 = 90;
            }
            if (var10 == 5) {
                var12 = -90;
            }
            if (var10 == 2 && p_180538_1_.adjacentChestXPos != null) {
                GlStateManager.translate(1.0f, 0.0f, 0.0f);
            }
            if (var10 == 5 && p_180538_1_.adjacentChestZPos != null) {
                GlStateManager.translate(0.0f, 0.0f, -1.0f);
            }
            GlStateManager.rotate(var12, 0.0f, 1.0f, 0.0f);
            GlStateManager.translate(-0.5f, -0.5f, -0.5f);
            float var13 = p_180538_1_.prevLidAngle + (p_180538_1_.lidAngle - p_180538_1_.prevLidAngle) * p_180538_8_;
            if (p_180538_1_.adjacentChestZNeg != null && (var14 = p_180538_1_.adjacentChestZNeg.prevLidAngle + (p_180538_1_.adjacentChestZNeg.lidAngle - p_180538_1_.adjacentChestZNeg.prevLidAngle) * p_180538_8_) > var13) {
                var13 = var14;
            }
            if (p_180538_1_.adjacentChestXNeg != null && (var14 = p_180538_1_.adjacentChestXNeg.prevLidAngle + (p_180538_1_.adjacentChestXNeg.lidAngle - p_180538_1_.adjacentChestXNeg.prevLidAngle) * p_180538_8_) > var13) {
                var13 = var14;
            }
            var13 = 1.0f - var13;
            var13 = 1.0f - var13 * var13 * var13;
            var15.chestLid.rotateAngleX = - var13 * 3.1415927f / 2.0f;
            var15.renderAll();
            GlStateManager.disableRescaleNormal();
            GlStateManager.popMatrix();
            GlStateManager.color(1.0f, 1.0f, 1.0f, 1.0f);
            if (p_180538_9_ >= 0) {
                GlStateManager.matrixMode(5890);
                GlStateManager.popMatrix();
                GlStateManager.matrixMode(5888);
            }
        }
    }

    @Override
    public void renderTileEntityAt(TileEntity p_180535_1_, double p_180535_2_, double p_180535_4_, double p_180535_6_, float p_180535_8_, int p_180535_9_) {
        if (Twelve.getInstance().getModHandler().getMod("ChestESP").getEnabled()) {
            GL11.glEnable((int)3042);
            GL11.glBlendFunc((int)770, (int)771);
            GL11.glEnable((int)2848);
            GL11.glHint((int)3154, (int)4354);
            GL11.glColor4f((float)(r / 255.0f), (float)(g / 255.0f), (float)(b / 255.0f), (float)1.0f);
            this.func_180538_a((TileEntityChest)p_180535_1_, p_180535_2_, p_180535_4_, p_180535_6_, p_180535_8_, p_180535_9_);
            TileEntityChestRenderer.renderOne();
            this.func_180538_a((TileEntityChest)p_180535_1_, p_180535_2_, p_180535_4_, p_180535_6_, p_180535_8_, p_180535_9_);
            TileEntityChestRenderer.renderTwo();
            this.func_180538_a((TileEntityChest)p_180535_1_, p_180535_2_, p_180535_4_, p_180535_6_, p_180535_8_, p_180535_9_);
            TileEntityChestRenderer.renderThree();
            this.func_180538_a((TileEntityChest)p_180535_1_, p_180535_2_, p_180535_4_, p_180535_6_, p_180535_8_, p_180535_9_);
            TileEntityChestRenderer.renderFour();
            this.func_180538_a((TileEntityChest)p_180535_1_, p_180535_2_, p_180535_4_, p_180535_6_, p_180535_8_, p_180535_9_);
            TileEntityChestRenderer.renderFive();
            GL11.glColor4f((float)1.0f, (float)1.0f, (float)1.0f, (float)1.0f);
            GL11.glDisable((int)3042);
            GL11.glDisable((int)2848);
        }
        this.func_180538_a((TileEntityChest)p_180535_1_, p_180535_2_, p_180535_4_, p_180535_6_, p_180535_8_, p_180535_9_);
    }

    public static void renderOne() {
        GL11.glPushAttrib((int)1048575);
        GL11.glDisable((int)3008);
        GL11.glDisable((int)3553);
        GL11.glDisable((int)2896);
        GL11.glEnable((int)3042);
        GL11.glBlendFunc((int)770, (int)771);
        GL11.glLineWidth((float)4.0f);
        GL11.glEnable((int)2848);
        GL11.glHint((int)3154, (int)4354);
        GL11.glEnable((int)2960);
        GL11.glClear((int)1024);
        GL11.glClearStencil((int)15);
        GL11.glStencilFunc((int)512, (int)1, (int)15);
        GL11.glStencilOp((int)7681, (int)7681, (int)7681);
        GL11.glPolygonMode((int)1028, (int)6913);
    }

    public static void renderTwo() {
        GL11.glStencilFunc((int)512, (int)0, (int)15);
        GL11.glStencilOp((int)7681, (int)7681, (int)7681);
        GL11.glPolygonMode((int)1028, (int)6914);
    }

    public static void renderThree() {
        GL11.glStencilFunc((int)514, (int)1, (int)15);
        GL11.glStencilOp((int)7680, (int)7680, (int)7680);
        GL11.glPolygonMode((int)1028, (int)6913);
    }

    public static void renderFour() {
        GL11.glEnable((int)10754);
        GL11.glPolygonOffset((float)1.0f, (float)-2000000.0f);
        OpenGlHelper.setLightmapTextureCoords(OpenGlHelper.lightmapTexUnit, 240.0f, 240.0f);
    }

    public static void renderFive() {
        GL11.glPolygonOffset((float)1.0f, (float)2000000.0f);
        GL11.glDisable((int)10754);
        GL11.glDisable((int)2960);
        GL11.glDisable((int)2848);
        GL11.glHint((int)3154, (int)4352);
        GL11.glDisable((int)3042);
        GL11.glEnable((int)2896);
        GL11.glEnable((int)3553);
        GL11.glEnable((int)3008);
        GL11.glPopAttrib();
    }

    public static void updateESPColours() {
        switch (state) {
            case 0: {
                if ((g += 1.0f) != 255.0f) break;
                state = 1;
                break;
            }
            case 1: {
                if ((r -= 1.0f) != 0.0f) break;
                state = 2;
                break;
            }
            case 2: {
                if ((b += 1.0f) != 255.0f) break;
                state = 3;
                break;
            }
            case 3: {
                if ((g -= 1.0f) != 0.0f) break;
                state = 4;
                break;
            }
            case 4: {
                if ((r += 1.0f) != 255.0f) break;
                state = 5;
                break;
            }
            case 5: {
                if ((b -= 1.0f) != 0.0f) break;
                state = 0;
            }
        }
    }
}

